;;; -*- Mode: asm; indent-tabs-mode: t; tab-width: 8 -*-
.scope line_test_time
        .include "line.inc"

        ;;START TIME HERE

        ;;for testing stuff
        Y_pos_ = $0D
        X_pos_ = $0E
        Y_end_ = $10
        X_end_ = $11
        LDA #$00
        STA X_pos_
        LDA #$30
        STA Y_pos_
        LDA #$ff
        STA X_end
        LDA #$30
        STA Y_end


@loop:;; mem f1
        LDA Y_pos_
        STA Y_pos
        LDA X_pos_
        STA X_pos

        jsr line
        INC Y_end
        LDA Y_end
        CMP #$50
        BEQ end__
        jmp @loop
end__:
        ;;Lets cleer bitmap
        B_start = $FCFD ;16-bit value (uses FD)
        B_end = $FEFF   ;16-bit value (uses FF)
        VIC_bank = $4000
        VIC_bank_end = VIC_bank + $3FFF
        ;;Paint the bitmap black. More bitmap: https://www.c64-wiki.com/wiki/53272, https://www.c64-wiki.com/wiki/Screen_RAM#Moving_of_screen_RAM
        Mov_16 B_start, B_start + 1, #<VIC_bank, #>VIC_bank
        Mov_16 B_end, B_end + 1, #<$5f3f,  #>$5f3f
        LDA #$00
        jsr memset
        jmp exit
.endscope
